//ИК приемник на атмега 8
//тактируется от внутреннего генератора 8 Мгц
//кнопка PD0 и минус
//ИК приемник PD2
//выход PB1 нагрузка 
//выход PB2 контрольный светодиод 

#include<avr/io.h>
#include<avr/interrupt.h>
#include <avr/wdt.h>
#include <EEPROM.h>

int counter=0;
int ii;
int q=0;
int q1=0;
int edgecounter=0;
byte massiv[18];
byte massiv1[18];
int t;
boolean w=false;

ISR(INT0_vect)
{
  massiv[edgecounter]=counter;
edgecounter++;
if (edgecounter==18) edgecounter=0;

	TCNT1H=0;//обнуляем регистр TCNT1
	TCNT1L=0;
        counter=0;
}

ISR(TIMER1_COMPA_vect)//обработчик прерывания по совпадению А (для счетчика А)
{
	TCNT1H=0;//обнуляем регистр TCNT1
	TCNT1L=0;
if (edgecounter>0) counter++;
if (counter==600) 
{
counter=0;
edgecounter=0;
}
}

void setup() {
 
    DDRD = 0b11111010; // Настраиваем входы/выходы
    PORTD = 0b00000001;
    DDRB = 0xFF; // Порт B выход
    PORTB = 0b00000010; // Лог. 1 на выходе пб1
    
//настройка таймера  
	TCCR1A = (0 << COM1A0); //не делать изменение состояния вывода OC0A на противоположное при совпадении с OCR1A
        TCCR1B = (0 << CS12)|(1 << CS11)|(1 << CS10); //выбор коэффициента предделителя 
	OCR1A = 1; //число для совпадения
	TIMSK = 0x10;//разрешаем прерывание по совпадению

//настройка счетчика	
TCCR0 |= (1 << CS01); // Предделитель на 8, частота таймера 1 MHz
TIMSK |= (1 << TOIE0); // Разрешаем прерывание от таймера Т0
GICR |= (1 << INT0); // Разрешаем внешнее прерывание на входе INT0
MCUCR |= (1 << ISC01)|(1 << ISC00); // Внешнее прерывание формируется по переднему фронту
sei(); // Глобально разрешаем прерывания
 
 //считываем код из памяти    
ii=2; while(ii<18){
massiv1[ii]=EEPROM.read( ii);
ii++;
}
 
//WDTO_2S;           // разрешение работы сторожевого таймера с тайм-аутом 2 сек 
}

void loop() {
  
  if (digitalRead(0) == LOW ) { //если кнопка нажата
   
   zero ();
   PORTB = 0b00000100; //включить светодиод 
   
    //проверяем наличие сигнала в буфере
   ii=2;
   t=0;
    while(t<15){
    if (massiv[ii] || 0) t++;
     ii++;
    if (ii>17) {ii=2; t=0;}

   }
  delay (500);
   // сигнал "включить свет" получен
      ii=2; while(ii<18){
    EEPROM.write( ii, massiv[ii]); //запись в EEPROM сигнала "включить свет"
    massiv1[ii]=massiv[ii]; // загрузка в массив1 сигнала "включить свет"
    ii++;
    }
    PORTB = 0b00000010;  //включить свет
   
   delay (500); 
   
   zero ();
    
    }
 

 //сравниваем число  с погрешностью +-20
 
  ii=2; while(ii<18){
  if ((massiv[ii]+20 > massiv1[ii]) && (massiv[ii]-20 < massiv1[ii])) q++;
  ii++;
  }
 
 
 if ((q==16) && (w==true))
  {w=false;
   PORTB = 0b00000010;  //включить свет
    zero ();
   q=0;
}

 if ((q==16) && (w==false))
  {w=true;
    PORTB = 0b00000100; //включить светодиод
    zero ();
  }

 q=0;
 
 // /wdt_reset();  // сброс сторожевого таймера
}


void zero ()
{
    ii=2; while(ii<18){ //затираем буфер
    massiv[ii]=0;
    ii++;
   }
 
  }

